//+------------------------------------------------------------------+
//|                                                    Impuse EA.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- input parameters
extern double TakeProfit = 50;
extern double Lots = 0.1;
extern double TrailingStop = 0;
extern double FixedStop = 300;
extern double MATrendPeriod=14;
extern double MACD_fast_EMA = 12;
extern double MACD_slow_EMA = 26;
extern double MACD_SMA = 9;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   return(0);
}
  

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   // indicator values
   double MacdCurrent, MacdPrevious;
   double MaCurrent, MaPrevious;
   
   int cnt, ticket, total;
   
   // check to see enough bars have been created before ea starts
   if(Bars<10)
   {
      Print("bars less than 10");
      return(0);  
   }
   
   // initialise indicators  
   MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   Print("Macd Current is ", MacdCurrent, " Macd Previous is ", MacdPrevious);  // checking the values every iteration
   
   // number of open or pending orders on the market
   total = OrdersTotal();
   //Print("Number of Orders is : " + total, " and ", OrdersTotal());
   
//+------------------------------------------------------------------+
//|         MAIN LOGIC FOR ENTRY                                     |
//+------------------------------------------------------------------+
   
   // Long Position
 //  if((MacdCurrent > MacdPrevious ) && (total == 0) && (MaCurrent > MaPrevious) && (buy_or_sell == "buy"))
 //  {        
 //     ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,10000,Ask-(FixedStop*Point),Ask+TakeProfit*Point,"macd sample",16384,0,Green);
        
  //    if(ticket>0)
 //     {
   //      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
  //       {
   //         Print("BUY order opened : ",OrderOpenPrice());         
    //        Print ("MACD level current is ", MacdCurrent, " and previous ",MacdPrevious );
    //        Print ("MA level current is ", MaCurrent, " and previous ",MaPrevious );
    //     }
    //  }
    //  else Print("Error opening BUY order : ",GetLastError()); 
    //  return(0); 
  // }   
   
   // Short Position
   if((MacdCurrent < MacdPrevious ) && (total == 0) && (MaCurrent < MaPrevious))
   {        
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,10000,Bid+(FixedStop*Point),Bid-(TakeProfit*Point),"macd sample",16384,0,Green);
        
      if(ticket>0)
      {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
         {
            Print("SELL order opened : ",OrderOpenPrice());         
            Print ("MACD level current is ", MacdCurrent, " and previous ",MacdPrevious );
            Print ("MA level current is ", MaCurrent, " and previous ",MaPrevious );
         }
      }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
   }
//+------------------------------------------------------------------+
//|    CHECKS EVERY ITERATION FOR POSITION CLOSE AND TP STOP         |
//+------------------------------------------------------------------+
   
   for(cnt=0;cnt<total;cnt++)
   {   
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
      {
         if(OrderType()==OP_BUY)   // long position is open
         {
            // should it be closed?
            if((MacdCurrent < MacdPrevious) || (MaCurrent < MaPrevious))
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
               Print ("MACD level current is ", MacdCurrent, " and previous ",MacdPrevious );
               Print ("MA level current is ", MaCurrent, " and previous ",MaPrevious );
               return(0); // exit
            }
            if(TrailingStop > 0)
            {
               if((Bid - (TrailingStop*Point)) > OrderStopLoss())
               {
                  Print("trailing stop moved, price ", Bid, " - ", TrailingStop*Point, " = ", Bid - TrailingStop*Point ," more than old stop of ",OrderStopLoss());
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(TrailingStop*Point),OrderTakeProfit(),0,Green);                 
                  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
                  Print("new stop loss is ", OrderStopLoss());
                  return(0);
               }
            }
         }
         
         if(OrderType()==OP_SELL)   // short position is open
         {
            // should it be closed?
            if((MacdCurrent > MacdPrevious) || (MaCurrent > MaPrevious))
            {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               Print ("MACD level current is ", MacdCurrent, " and previous ",MacdPrevious );
               Print ("MA level current is ", MaCurrent, " and previous ",MaPrevious );
               return(0); // exit
            }
            if(TrailingStop > 0)
            {
               if((Ask - (TrailingStop*Point)) > OrderStopLoss())
               {
                  Print("trailing stop moved, price ", Ask, " + ", TrailingStop*Point, " = ", Ask + TrailingStop*Point ," more than old stop of ",OrderStopLoss());
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(TrailingStop*Point),OrderTakeProfit(),0,Green);                 
                  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
                  Print("new stop loss is ", OrderStopLoss());
                  return(0);
               }
            }
         }
      }
   }     // end of for loop   
  
   return(0);
}
//+------------------------------------------------------------------+